/* plugin.c generated by valac 0.16.1, the Vala compiler
 * generated from plugin.vala, do not modify */

/*
 * Copyright (C) 2009-2012 Michael 'Mickey' Lauer <mlauer@vanille-media.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <fsotdl.h>
#include <gio/gio.h>
#include <fsobasics.h>
#include <arpa/inet.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <linux/rtnetlink.h>
#include <fsoframework.h>


#define NETWORK_TIME_PROTOCOL_TYPE_TIME_STAMP (network_time_protocol_time_stamp_get_type ())
typedef struct _NetworkTimeProtocolTimeStamp NetworkTimeProtocolTimeStamp;

#define NETWORK_TIME_PROTOCOL_TYPE_PACKET (network_time_protocol_packet_get_type ())
typedef struct _NetworkTimeProtocolPacket NetworkTimeProtocolPacket;

#define SOURCE_TYPE_NTP (source_ntp_get_type ())
#define SOURCE_NTP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_TYPE_NTP, SourceNtp))
#define SOURCE_NTP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_TYPE_NTP, SourceNtpClass))
#define SOURCE_IS_NTP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_TYPE_NTP))
#define SOURCE_IS_NTP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_TYPE_NTP))
#define SOURCE_NTP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_TYPE_NTP, SourceNtpClass))

typedef struct _SourceNtp SourceNtp;
typedef struct _SourceNtpClass SourceNtpClass;
typedef struct _SourceNtpPrivate SourceNtpPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NetworkTimeProtocolTimeStamp {
	guint32 secs;
	guint32 usecs;
};

struct _NetworkTimeProtocolPacket {
	guint8 flags;
	guint8 stratum;
	guint8 poll;
	gint8 precision;
	gint root_delay;
	gint root_dispersion;
	gchar refaddr[4];
	NetworkTimeProtocolTimeStamp reference;
	NetworkTimeProtocolTimeStamp originate;
	NetworkTimeProtocolTimeStamp received;
	NetworkTimeProtocolTimeStamp transmit;
};

struct _SourceNtp {
	FsoTimeAbstractSource parent_instance;
	SourceNtpPrivate * priv;
};

struct _SourceNtpClass {
	FsoTimeAbstractSourceClass parent_class;
};

struct _SourceNtpPrivate {
	gchar* servername;
	GInetAddress* serveraddr;
	GSocket* socket;
	GIOChannel* channel;
	guint watch;
	NetworkTimeProtocolPacket request;
	NetworkTimeProtocolPacket packet;
};


static gpointer source_ntp_parent_class = NULL;
static GType source_ntp_type_id = 0;

#define NETWORK_TIME_PROTOCOL_DEFAULT_SERVER "pool.ntp.org"
#define NETWORK_TIME_PROTOCOL_PORT ((guint16) 123)
#define NETWORK_TIME_PROTOCOL_BASETIME ((guint32) 2208988800LL)
GType network_time_protocol_time_stamp_get_type (void) G_GNUC_CONST;
NetworkTimeProtocolTimeStamp* network_time_protocol_time_stamp_dup (const NetworkTimeProtocolTimeStamp* self);
void network_time_protocol_time_stamp_free (NetworkTimeProtocolTimeStamp* self);
GType network_time_protocol_packet_get_type (void) G_GNUC_CONST;
NetworkTimeProtocolPacket* network_time_protocol_packet_dup (const NetworkTimeProtocolPacket* self);
void network_time_protocol_packet_free (NetworkTimeProtocolPacket* self);
GType source_ntp_get_type (void) G_GNUC_CONST;
GType source_ntp_register_type (GTypeModule * module);
#define SOURCE_NTP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SOURCE_TYPE_NTP, SourceNtpPrivate))
enum  {
	SOURCE_NTP_DUMMY_PROPERTY
};
#define SOURCE_NTP_MODULE_NAME "fsotdl.source_ntp"
static gchar* source_ntp_real_repr (FsoFrameworkAbstractObject* base);
static void source_ntp_real_triggerQuery (FsoTimeAbstractSource* base);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
static gboolean source_ntp_onIncomingSocketData (SourceNtp* self, GIOChannel* source, GIOCondition condition);
static gboolean _source_ntp_onIncomingSocketData_gio_func (GIOChannel* source, GIOCondition condition, gpointer self);
static gboolean source_ntp_handleUpdatePacket (SourceNtp* self);
static gboolean _source_ntp_handleUpdatePacket_gsource_func (gpointer self);
static void source_ntp_onNetlinkNewRoute (SourceNtp* self, GHashTable* properties);
static gboolean ___lambda2_ (SourceNtp* self);
static gboolean ____lambda2__gsource_func (gpointer self);
SourceNtp* source_ntp_new (void);
SourceNtp* source_ntp_construct (GType object_type);
static GObject * source_ntp_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gboolean _source_ntp___lambda3_ (SourceNtp* self);
static gboolean __source_ntp___lambda3__gsource_func (gpointer self);
static void _source_ntp_onNetlinkNewRoute_fso_framework_netlink_notifier_func (GHashTable* properties, gpointer self);
static void source_ntp_finalize (GObject* obj);
gchar* fso_factory_function (FsoFrameworkSubsystem* subsystem, GError** error);
void fso_register_function (GTypeModule* module);


NetworkTimeProtocolTimeStamp* network_time_protocol_time_stamp_dup (const NetworkTimeProtocolTimeStamp* self) {
	NetworkTimeProtocolTimeStamp* dup;
	dup = g_new0 (NetworkTimeProtocolTimeStamp, 1);
	memcpy (dup, self, sizeof (NetworkTimeProtocolTimeStamp));
	return dup;
}


void network_time_protocol_time_stamp_free (NetworkTimeProtocolTimeStamp* self) {
	g_free (self);
}


GType network_time_protocol_time_stamp_get_type (void) {
	static volatile gsize network_time_protocol_time_stamp_type_id__volatile = 0;
	if (g_once_init_enter (&network_time_protocol_time_stamp_type_id__volatile)) {
		GType network_time_protocol_time_stamp_type_id;
		network_time_protocol_time_stamp_type_id = g_boxed_type_register_static ("NetworkTimeProtocolTimeStamp", (GBoxedCopyFunc) network_time_protocol_time_stamp_dup, (GBoxedFreeFunc) network_time_protocol_time_stamp_free);
		g_once_init_leave (&network_time_protocol_time_stamp_type_id__volatile, network_time_protocol_time_stamp_type_id);
	}
	return network_time_protocol_time_stamp_type_id__volatile;
}


NetworkTimeProtocolPacket* network_time_protocol_packet_dup (const NetworkTimeProtocolPacket* self) {
	NetworkTimeProtocolPacket* dup;
	dup = g_new0 (NetworkTimeProtocolPacket, 1);
	memcpy (dup, self, sizeof (NetworkTimeProtocolPacket));
	return dup;
}


void network_time_protocol_packet_free (NetworkTimeProtocolPacket* self) {
	g_free (self);
}


GType network_time_protocol_packet_get_type (void) {
	static volatile gsize network_time_protocol_packet_type_id__volatile = 0;
	if (g_once_init_enter (&network_time_protocol_packet_type_id__volatile)) {
		GType network_time_protocol_packet_type_id;
		network_time_protocol_packet_type_id = g_boxed_type_register_static ("NetworkTimeProtocolPacket", (GBoxedCopyFunc) network_time_protocol_packet_dup, (GBoxedFreeFunc) network_time_protocol_packet_free);
		g_once_init_leave (&network_time_protocol_packet_type_id__volatile, network_time_protocol_packet_type_id);
	}
	return network_time_protocol_packet_type_id__volatile;
}


static gchar* source_ntp_real_repr (FsoFrameworkAbstractObject* base) {
	SourceNtp * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	GInetAddress* _tmp1_;
	self = (SourceNtp*) base;
	_tmp1_ = self->priv->serveraddr;
	if (_tmp1_ == NULL) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("<unknown>");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	} else {
		GInetAddress* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		_tmp3_ = self->priv->serveraddr;
		_tmp4_ = g_inet_address_to_string (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strconcat ("<", _tmp5_, ">", NULL);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp6_;
		_g_free0 (_tmp5_);
	}
	result = _tmp0_;
	return result;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean _source_ntp_onIncomingSocketData_gio_func (GIOChannel* source, GIOCondition condition, gpointer self) {
	gboolean result;
	result = source_ntp_onIncomingSocketData (self, source, condition);
	return result;
}


static void source_ntp_real_triggerQuery (FsoTimeAbstractSource* base) {
	SourceNtp * self;
	GInetAddress* _tmp0_;
	GInetAddress* _tmp32_;
	GInetSocketAddress* _tmp33_;
	GInetSocketAddress* targetaddr;
	guint8* request_data;
	gint request_data_length1;
	gint _request_data_size_;
	gint _tmp34_;
	GSocket* _tmp35_;
	GInetSocketAddress* _tmp36_;
	guint8* _tmp37_;
	gint _tmp37__length1;
	gssize _tmp38_ = 0L;
	gssize sent;
	FsoFrameworkLogger* _tmp39_;
	gssize _tmp40_;
	gchar* _tmp41_ = NULL;
	gchar* _tmp42_;
	gchar* _tmp43_ = NULL;
	gchar* _tmp44_;
	gboolean _tmp45_ = FALSE;
	GError * _inner_error_ = NULL;
	self = (SourceNtp*) base;
	_tmp0_ = self->priv->serveraddr;
	if (_tmp0_ == NULL) {
		GResolver* _tmp1_ = NULL;
		GResolver* resolver;
		GList* addresses;
		GList* _tmp12_;
		gconstpointer _tmp13_ = NULL;
		GInetAddress* _tmp14_;
		FsoFrameworkLogger* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_ = NULL;
		GInetAddress* _tmp18_;
		gchar* _tmp19_ = NULL;
		gchar* _tmp20_;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		gboolean _tmp23_ = FALSE;
		GSocket* _tmp24_;
		GSocket* _tmp25_;
		GSocket* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		GIOChannel* _tmp29_;
		GIOChannel* _tmp30_;
		guint _tmp31_ = 0U;
		_tmp1_ = g_resolver_get_default ();
		resolver = _tmp1_;
		addresses = NULL;
		{
			GResolver* _tmp2_;
			const gchar* _tmp3_;
			GList* _tmp4_ = NULL;
			GList* _tmp5_;
			_tmp2_ = resolver;
			_tmp3_ = self->priv->servername;
			_tmp4_ = g_resolver_lookup_by_name (_tmp2_, _tmp3_, NULL, &_inner_error_);
			_tmp5_ = _tmp4_;
			if (_inner_error_ != NULL) {
				goto __catch0_g_error;
			}
			__g_list_free__g_object_unref0_0 (addresses);
			addresses = _tmp5_;
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			FsoFrameworkLogger* _tmp6_;
			GError* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_ = NULL;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp6_ = ((FsoFrameworkAbstractObject*) self)->logger;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			_tmp9_ = string_to_string (_tmp8_);
			_tmp10_ = g_strconcat ("Could not resolve NTP server address ", _tmp9_, ". Will try again next time.", NULL);
			_tmp11_ = _tmp10_;
			fso_framework_logger_warning (_tmp6_, _tmp11_);
			_g_free0 (_tmp11_);
			_g_error_free0 (e);
			__g_list_free__g_object_unref0_0 (addresses);
			_g_object_unref0 (resolver);
			return;
		}
		__finally0:
		if (_inner_error_ != NULL) {
			__g_list_free__g_object_unref0_0 (addresses);
			_g_object_unref0 (resolver);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp12_ = addresses;
		_tmp13_ = g_list_nth_data (_tmp12_, (guint) 0);
		_tmp14_ = _g_object_ref0 ((GInetAddress*) _tmp13_);
		_g_object_unref0 (self->priv->serveraddr);
		self->priv->serveraddr = _tmp14_;
		_tmp15_ = ((FsoFrameworkAbstractObject*) self)->logger;
		_tmp16_ = self->priv->servername;
		_tmp17_ = string_to_string (_tmp16_);
		_tmp18_ = self->priv->serveraddr;
		_tmp19_ = g_inet_address_to_string (_tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_strconcat ("Resolved ", _tmp17_, " to ", _tmp20_, NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = fso_framework_logger_debug (_tmp15_, _tmp22_);
		g_assert (_tmp23_);
		_g_free0 (_tmp22_);
		_g_free0 (_tmp20_);
		_tmp24_ = g_socket_new (G_SOCKET_FAMILY_IPV4, G_SOCKET_TYPE_DATAGRAM, G_SOCKET_PROTOCOL_UDP, &_inner_error_);
		_tmp25_ = _tmp24_;
		if (_inner_error_ != NULL) {
			__g_list_free__g_object_unref0_0 (addresses);
			_g_object_unref0 (resolver);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_object_unref0 (self->priv->socket);
		self->priv->socket = _tmp25_;
		_tmp26_ = self->priv->socket;
		_tmp27_ = g_socket_get_fd (_tmp26_);
		_tmp28_ = _tmp27_;
		_tmp29_ = g_io_channel_unix_new (_tmp28_);
		_g_io_channel_unref0 (self->priv->channel);
		self->priv->channel = _tmp29_;
		_tmp30_ = self->priv->channel;
		_tmp31_ = g_io_add_watch (_tmp30_, G_IO_IN | G_IO_HUP, _source_ntp_onIncomingSocketData_gio_func, self);
		self->priv->watch = _tmp31_;
		__g_list_free__g_object_unref0_0 (addresses);
		_g_object_unref0 (resolver);
	}
	_tmp32_ = self->priv->serveraddr;
	_tmp33_ = (GInetSocketAddress*) g_inet_socket_address_new (_tmp32_, NETWORK_TIME_PROTOCOL_PORT);
	targetaddr = _tmp33_;
	request_data = (guint8*) (&self->priv->request);
	request_data_length1 = -1;
	_request_data_size_ = request_data_length1;
	request_data_length1 = (gint) sizeof (NetworkTimeProtocolPacket);
	_tmp34_ = request_data_length1;
	_tmp35_ = self->priv->socket;
	_tmp36_ = targetaddr;
	_tmp37_ = request_data;
	_tmp37__length1 = request_data_length1;
	_tmp38_ = g_socket_send_to (_tmp35_, (GSocketAddress*) _tmp36_, _tmp37_, (gsize) _tmp37__length1, NULL, &_inner_error_);
	sent = _tmp38_;
	if (_inner_error_ != NULL) {
		_g_object_unref0 (targetaddr);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp39_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp40_ = sent;
	_tmp41_ = g_strdup_printf ("%" G_GSSIZE_FORMAT, _tmp40_);
	_tmp42_ = _tmp41_;
	_tmp43_ = g_strconcat ("Sent ", _tmp42_, " bytes to socket to request NTP timestamp.", NULL);
	_tmp44_ = _tmp43_;
	_tmp45_ = fso_framework_logger_debug (_tmp39_, _tmp44_);
	g_assert (_tmp45_);
	_g_free0 (_tmp44_);
	_g_free0 (_tmp42_);
	_g_object_unref0 (targetaddr);
}


static gboolean _source_ntp_handleUpdatePacket_gsource_func (gpointer self) {
	gboolean result;
	result = source_ntp_handleUpdatePacket (self);
	return result;
}


static gboolean source_ntp_onIncomingSocketData (SourceNtp* self, GIOChannel* source, GIOCondition condition) {
	gboolean result = FALSE;
	FsoFrameworkLogger* _tmp0_;
	GIOCondition _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GIOCondition _tmp5_;
	GIOCondition _tmp7_;
	FsoFrameworkLogger* _tmp20_;
	GIOCondition _tmp21_;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	_tmp0_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp1_ = condition;
	_tmp2_ = g_strdup_printf ("onIncomingSocketData called with condition = %d", (gint) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = fso_framework_logger_debug (_tmp0_, _tmp3_);
	g_assert (_tmp4_);
	_g_free0 (_tmp3_);
	_tmp5_ = condition;
	if ((_tmp5_ & G_IO_HUP) == G_IO_HUP) {
		FsoFrameworkLogger* _tmp6_;
		_tmp6_ = ((FsoFrameworkAbstractObject*) self)->logger;
		fso_framework_logger_warning (_tmp6_, "HUP from NTP socket");
		result = FALSE;
		return result;
	}
	_tmp7_ = condition;
	if ((_tmp7_ & G_IO_IN) == G_IO_IN) {
		GSocketAddress* reply_address = NULL;
		guint8* packet_data;
		gint packet_data_length1;
		gint _packet_data_size_;
		gint _tmp8_;
		GSocket* _tmp9_;
		guint8* _tmp10_;
		gint _tmp10__length1;
		GSocketAddress* _tmp11_ = NULL;
		gssize _tmp12_ = 0L;
		gssize received;
		FsoFrameworkLogger* _tmp13_;
		gssize _tmp14_;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_;
		gboolean _tmp19_ = FALSE;
		packet_data = (guint8*) (&self->priv->packet);
		packet_data_length1 = -1;
		_packet_data_size_ = packet_data_length1;
		packet_data_length1 = (gint) sizeof (NetworkTimeProtocolPacket);
		_tmp8_ = packet_data_length1;
		_tmp9_ = self->priv->socket;
		_tmp10_ = packet_data;
		_tmp10__length1 = packet_data_length1;
		_tmp12_ = g_socket_receive_from (_tmp9_, &_tmp11_, _tmp10_, (gsize) _tmp10__length1, NULL, &_inner_error_);
		_g_object_unref0 (reply_address);
		reply_address = _tmp11_;
		received = _tmp12_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (reply_address);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		_tmp13_ = ((FsoFrameworkAbstractObject*) self)->logger;
		_tmp14_ = received;
		_tmp15_ = g_strdup_printf ("%" G_GSSIZE_FORMAT, _tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = g_strconcat ("Received ", _tmp16_, " bytes from socket.", NULL);
		_tmp18_ = _tmp17_;
		_tmp19_ = fso_framework_logger_debug (_tmp13_, _tmp18_);
		g_assert (_tmp19_);
		_g_free0 (_tmp18_);
		_g_free0 (_tmp16_);
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _source_ntp_handleUpdatePacket_gsource_func, g_object_ref (self), g_object_unref);
		result = TRUE;
		_g_object_unref0 (reply_address);
		return result;
	}
	_tmp20_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp21_ = condition;
	_tmp22_ = g_strdup_printf ("onIncomingSocketData called with unknown condition %d", (gint) _tmp21_);
	_tmp23_ = _tmp22_;
	fso_framework_logger_warning (_tmp20_, _tmp23_);
	_g_free0 (_tmp23_);
	result = FALSE;
	return result;
}


static void g_time_gm (time_t time, struct tm* result) {
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	gmtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}


static gboolean source_ntp_handleUpdatePacket (SourceNtp* self) {
	gboolean result = FALSE;
	NetworkTimeProtocolPacket _tmp0_;
	NetworkTimeProtocolTimeStamp _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_ = 0U;
	guint32 tempstmp;
	NetworkTimeProtocolPacket _tmp4_;
	NetworkTimeProtocolTimeStamp _tmp5_;
	guint32 _tmp6_;
	guint32 _tmp7_ = 0U;
	guint32 tempfrac;
	time_t temptime;
	struct tm _tmp8_ = {0};
	struct tm bd;
	struct tm _tmp9_;
	gint _tmp10_;
	gdouble fractime;
	FsoFrameworkLogger* _tmp11_;
	struct tm _tmp12_;
	gint _tmp13_;
	struct tm _tmp14_;
	gint _tmp15_;
	struct tm _tmp16_;
	gint _tmp17_;
	struct tm _tmp18_;
	gint _tmp19_;
	struct tm _tmp20_;
	gint _tmp21_;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->packet;
	_tmp1_ = _tmp0_.transmit;
	_tmp2_ = _tmp1_.secs;
	_tmp3_ = ntohl (_tmp2_);
	tempstmp = _tmp3_;
	_tmp4_ = self->priv->packet;
	_tmp5_ = _tmp4_.transmit;
	_tmp6_ = _tmp5_.usecs;
	_tmp7_ = ntohl (_tmp6_);
	tempfrac = _tmp7_;
	temptime = (time_t) (tempstmp - NETWORK_TIME_PROTOCOL_BASETIME);
	g_signal_emit_by_name ((FsoTimeSource*) self, "report-time", (gint) temptime, (FsoTimeSource*) self);
	g_time_gm (temptime, &_tmp8_);
	bd = _tmp8_;
	_tmp9_ = bd;
	_tmp10_ = _tmp9_.tm_sec;
	fractime = _tmp10_ + (tempfrac / 4294967296.0);
	_tmp11_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp12_ = bd;
	_tmp13_ = _tmp12_.tm_year;
	_tmp14_ = bd;
	_tmp15_ = _tmp14_.tm_mon;
	_tmp16_ = bd;
	_tmp17_ = _tmp16_.tm_mday;
	_tmp18_ = bd;
	_tmp19_ = _tmp18_.tm_hour;
	_tmp20_ = bd;
	_tmp21_ = _tmp20_.tm_min;
	_tmp22_ = g_strdup_printf ("NTP: %04d-%02d-%02d %02d:%02d:%07.4f UTC", _tmp13_ + 1900, _tmp15_, _tmp17_, _tmp19_, _tmp21_, fractime);
	_tmp23_ = _tmp22_;
	fso_framework_logger_info (_tmp11_, _tmp23_);
	_g_free0 (_tmp23_);
	result = FALSE;
	return result;
}


static gboolean ___lambda2_ (SourceNtp* self) {
	gboolean result = FALSE;
	fso_time_abstract_source_triggerQuery ((FsoTimeAbstractSource*) self);
	result = FALSE;
	return result;
}


static gboolean ____lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda2_ (self);
	return result;
}


static void source_ntp_onNetlinkNewRoute (SourceNtp* self, GHashTable* properties) {
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* scope;
	const gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (properties != NULL);
	_tmp0_ = properties;
	_tmp1_ = g_hash_table_lookup (_tmp0_, "ROUTE_SCOPE");
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	scope = _tmp2_;
	_tmp3_ = scope;
	if (_tmp3_ != NULL) {
		FsoFrameworkLogger* _tmp4_;
		gboolean _tmp5_ = FALSE;
		_tmp4_ = ((FsoFrameworkAbstractObject*) self)->logger;
		_tmp5_ = fso_framework_logger_debug (_tmp4_, "Route has changed; triggering NTP sync");
		g_assert (_tmp5_);
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda2__gsource_func, g_object_ref (self), g_object_unref);
	}
	_g_free0 (scope);
}


SourceNtp* source_ntp_construct (GType object_type) {
	SourceNtp * self = NULL;
	self = (SourceNtp*) fso_time_abstract_source_construct (object_type);
	return self;
}


SourceNtp* source_ntp_new (void) {
	return source_ntp_construct (SOURCE_TYPE_NTP);
}


static gboolean _source_ntp___lambda3_ (SourceNtp* self) {
	gboolean result = FALSE;
	fso_time_abstract_source_triggerQuery ((FsoTimeAbstractSource*) self);
	result = FALSE;
	return result;
}


static gboolean __source_ntp___lambda3__gsource_func (gpointer self) {
	gboolean result;
	result = _source_ntp___lambda3_ (self);
	return result;
}


static void _source_ntp_onNetlinkNewRoute_fso_framework_netlink_notifier_func (GHashTable* properties, gpointer self) {
	source_ntp_onNetlinkNewRoute (self, properties);
}


static GObject * source_ntp_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SourceNtp * self;
	FsoFrameworkSmartKeyFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	NetworkTimeProtocolPacket _tmp2_ = {0};
	NetworkTimeProtocolPacket _tmp3_;
	parent_class = G_OBJECT_CLASS (source_ntp_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SOURCE_NTP (obj);
	_tmp0_ = ((FsoFrameworkAbstractObject*) self)->config;
	_tmp1_ = fso_framework_smart_key_file_stringValue (_tmp0_, SOURCE_NTP_MODULE_NAME, "server", NETWORK_TIME_PROTOCOL_DEFAULT_SERVER);
	_g_free0 (self->priv->servername);
	self->priv->servername = _tmp1_;
	memset (&_tmp2_, 0, sizeof (NetworkTimeProtocolPacket));
	_tmp2_.flags = (guint8) 0x1b;
	self->priv->request = _tmp2_;
	_tmp3_ = self->priv->request;
	memset (&self->priv->packet, 0, sizeof (NetworkTimeProtocolPacket));
	g_assert (((gulong) 48) == sizeof (NetworkTimeProtocolPacket));
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __source_ntp___lambda3__gsource_func, g_object_ref (self), g_object_unref);
	fso_framework_base_netlink_notifier_addMatch ((guint16) RTM_NEWROUTE, _source_ntp_onNetlinkNewRoute_fso_framework_netlink_notifier_func, self);
	return obj;
}


static void source_ntp_class_init (SourceNtpClass * klass) {
	source_ntp_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SourceNtpPrivate));
	FSO_FRAMEWORK_ABSTRACT_OBJECT_CLASS (klass)->repr = source_ntp_real_repr;
	FSO_TIME_ABSTRACT_SOURCE_CLASS (klass)->triggerQuery = source_ntp_real_triggerQuery;
	G_OBJECT_CLASS (klass)->constructor = source_ntp_constructor;
	G_OBJECT_CLASS (klass)->finalize = source_ntp_finalize;
}


static void source_ntp_instance_init (SourceNtp * self) {
	self->priv = SOURCE_NTP_GET_PRIVATE (self);
}


static void source_ntp_finalize (GObject* obj) {
	SourceNtp * self;
	self = SOURCE_NTP (obj);
	_g_free0 (self->priv->servername);
	_g_object_unref0 (self->priv->serveraddr);
	_g_object_unref0 (self->priv->socket);
	_g_io_channel_unref0 (self->priv->channel);
	G_OBJECT_CLASS (source_ntp_parent_class)->finalize (obj);
}


GType source_ntp_get_type (void) {
	return source_ntp_type_id;
}


GType source_ntp_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (SourceNtpClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_ntp_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceNtp), 0, (GInstanceInitFunc) source_ntp_instance_init, NULL };
	source_ntp_type_id = g_type_module_register_type (module, FSO_TIME_TYPE_ABSTRACT_SOURCE, "SourceNtp", &g_define_type_info, 0);
	return source_ntp_type_id;
}


/**
 * This function gets called on plugin initialization time.
 * @return the name of your plugin here
 * @note that it needs to be a name in the format <subsystem>.<plugin>
 * else your module will be unloaded immediately.
 **/
gchar* fso_factory_function (FsoFrameworkSubsystem* subsystem, GError** error) {
	gchar* result = NULL;
	FsoFrameworkLogger* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (subsystem != NULL, NULL);
	_tmp0_ = fso_framework_theLogger;
	fso_framework_logger_debug (_tmp0_, "fsotdl.source_ntp fso_factory_function");
	_tmp1_ = g_strdup (SOURCE_NTP_MODULE_NAME);
	result = _tmp1_;
	return result;
}


void fso_register_function (GTypeModule* module) {
	FsoFrameworkLogger* _tmp0_;
	g_return_if_fail (module != NULL);
	source_ntp_register_type (module);
	_tmp0_ = fso_framework_theLogger;
	fso_framework_logger_debug (_tmp0_, "fsotdl.source_ntp fso_register_function");
}



