/* plugin.c generated by valac 0.16.1, the Vala compiler
 * generated from plugin.vala, do not modify */

/*
 * Copyright (C) 2009-2012 Michael 'Mickey' Lauer <mlauer@vanille-media.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <fsobasics.h>
#include <fsoframework.h>
#include <gee.h>
#include <fsotdl.h>
#include <float.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>
#include <errno.h>
#include <glib/gstdio.h>


#define SYNC_TIME_TYPE_SERVICE (sync_time_service_get_type ())
#define SYNC_TIME_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SYNC_TIME_TYPE_SERVICE, SyncTimeService))
#define SYNC_TIME_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SYNC_TIME_TYPE_SERVICE, SyncTimeServiceClass))
#define SYNC_TIME_IS_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SYNC_TIME_TYPE_SERVICE))
#define SYNC_TIME_IS_SERVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SYNC_TIME_TYPE_SERVICE))
#define SYNC_TIME_SERVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SYNC_TIME_TYPE_SERVICE, SyncTimeServiceClass))

typedef struct _SyncTimeService SyncTimeService;
typedef struct _SyncTimeServiceClass SyncTimeServiceClass;
typedef struct _SyncTimeServicePrivate SyncTimeServicePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SyncTimeService {
	FsoFrameworkAbstractObject parent_instance;
	SyncTimeServicePrivate * priv;
};

struct _SyncTimeServiceClass {
	FsoFrameworkAbstractObjectClass parent_class;
};

struct _SyncTimeServicePrivate {
	FsoFrameworkSubsystem* subsystem;
	GeeHashMap* sources;
	gchar* timezone_file;
	gchar* localtime_file;
	gchar* zoneinfo_dir;
	gboolean try_adjtime;
};


static gpointer sync_time_service_parent_class = NULL;
static GType sync_time_service_type_id = 0;
extern SyncTimeService* service;
SyncTimeService* service = NULL;

#define SYNC_TIME_MODULE_NAME "fsotdl.sync_time"
#define SYNC_TIME_TIMEZONE_FILE_DEFAULT "/etc/timezone"
#define SYNC_TIME_LOCALTIME_FILE_DEFAULT "/etc/localtime"
#define SYNC_TIME_ZONEINFO_DIR_DEFAULT "/usr/share/zoneinfo"
GType sync_time_service_get_type (void) G_GNUC_CONST;
GType sync_time_service_register_type (GTypeModule * module);
#define SYNC_TIME_SERVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SYNC_TIME_TYPE_SERVICE, SyncTimeServicePrivate))
enum  {
	SYNC_TIME_SERVICE_DUMMY_PROPERTY
};
SyncTimeService* sync_time_service_new (FsoFrameworkSubsystem* subsystem);
SyncTimeService* sync_time_service_construct (GType object_type, FsoFrameworkSubsystem* subsystem);
void sync_time_service_addSource (SyncTimeService* self, const gchar* name);
void sync_time_service_onTimeReport (SyncTimeService* self, gint since_epoch, FsoTimeSource* source);
static void _sync_time_service_onTimeReport_fso_time_source_report_time (FsoTimeSource* _sender, gint since_epoch, FsoTimeSource* source, gpointer self);
void sync_time_service_onZoneReport (SyncTimeService* self, const gchar* zone, FsoTimeSource* source);
static void _sync_time_service_onZoneReport_fso_time_source_report_zone (FsoTimeSource* _sender, const gchar* zone, FsoTimeSource* source, gpointer self);
void sync_time_service_onLocationReport (SyncTimeService* self, gdouble lat, gdouble lon, gint height, FsoTimeSource* source);
static void _sync_time_service_onLocationReport_fso_time_source_report_location (FsoTimeSource* _sender, gdouble lat, gdouble lon, gint height, FsoTimeSource* source, gpointer self);
static gchar* sync_time_service_real_repr (FsoFrameworkAbstractObject* base);
static void sync_time_service_finalize (GObject* obj);
gchar* fso_factory_function (FsoFrameworkSubsystem* subsystem, GError** error);
void fso_register_function (GTypeModule* module);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gchar* bool_to_string (gboolean self) {
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}


SyncTimeService* sync_time_service_construct (GType object_type, FsoFrameworkSubsystem* subsystem) {
	SyncTimeService * self = NULL;
	GeeHashMap* _tmp0_;
	FsoFrameworkSmartKeyFile* _tmp1_;
	gchar** _tmp2_ = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	gchar** _tmp5_ = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** sourcenames;
	gint sourcenames_length1;
	gint _sourcenames_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	FsoFrameworkSmartKeyFile* _tmp10_;
	gchar* _tmp11_ = NULL;
	FsoFrameworkSmartKeyFile* _tmp12_;
	gchar* _tmp13_ = NULL;
	FsoFrameworkSmartKeyFile* _tmp14_;
	gchar* _tmp15_ = NULL;
	FsoFrameworkSmartKeyFile* _tmp16_;
	gboolean _tmp17_ = FALSE;
	FsoFrameworkLogger* _tmp18_;
	gboolean _tmp19_;
	gchar* _tmp20_ = NULL;
	gchar* _tmp21_;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	FsoFrameworkLogger* _tmp24_;
	GeeHashMap* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gchar* _tmp28_ = NULL;
	gchar* _tmp29_;
	gchar* _tmp30_ = NULL;
	gchar* _tmp31_;
	g_return_val_if_fail (subsystem != NULL, NULL);
	self = (SyncTimeService*) fso_framework_abstract_object_construct (object_type);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, FSO_TIME_TYPE_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->sources);
	self->priv->sources = _tmp0_;
	_tmp1_ = ((FsoFrameworkAbstractObject*) self)->config;
	_tmp2_ = g_new0 (gchar*, 0 + 1);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = 0;
	_tmp5_ = fso_framework_smart_key_file_stringListValue (_tmp1_, SYNC_TIME_MODULE_NAME, "sources", _tmp3_, 0, &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp4_;
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	sourcenames = _tmp6_;
	sourcenames_length1 = _tmp6__length1;
	_sourcenames_size_ = sourcenames_length1;
	_tmp7_ = sourcenames;
	_tmp7__length1 = sourcenames_length1;
	{
		gchar** source_collection = NULL;
		gint source_collection_length1 = 0;
		gint _source_collection_size_ = 0;
		gint source_it = 0;
		source_collection = _tmp7_;
		source_collection_length1 = _tmp7__length1;
		for (source_it = 0; source_it < _tmp7__length1; source_it = source_it + 1) {
			gchar* _tmp8_;
			gchar* source = NULL;
			_tmp8_ = g_strdup (source_collection[source_it]);
			source = _tmp8_;
			{
				const gchar* _tmp9_;
				_tmp9_ = source;
				sync_time_service_addSource (self, _tmp9_);
				_g_free0 (source);
			}
		}
	}
	_tmp10_ = ((FsoFrameworkAbstractObject*) self)->config;
	_tmp11_ = fso_framework_smart_key_file_stringValue (_tmp10_, SYNC_TIME_MODULE_NAME, "timezone_file", SYNC_TIME_TIMEZONE_FILE_DEFAULT);
	_g_free0 (self->priv->timezone_file);
	self->priv->timezone_file = _tmp11_;
	_tmp12_ = ((FsoFrameworkAbstractObject*) self)->config;
	_tmp13_ = fso_framework_smart_key_file_stringValue (_tmp12_, SYNC_TIME_MODULE_NAME, "localtime_file", SYNC_TIME_LOCALTIME_FILE_DEFAULT);
	_g_free0 (self->priv->localtime_file);
	self->priv->localtime_file = _tmp13_;
	_tmp14_ = ((FsoFrameworkAbstractObject*) self)->config;
	_tmp15_ = fso_framework_smart_key_file_stringValue (_tmp14_, SYNC_TIME_MODULE_NAME, "zoneinfo_dir", SYNC_TIME_ZONEINFO_DIR_DEFAULT);
	_g_free0 (self->priv->zoneinfo_dir);
	self->priv->zoneinfo_dir = _tmp15_;
	_tmp16_ = ((FsoFrameworkAbstractObject*) self)->config;
	_tmp17_ = fso_framework_smart_key_file_boolValue (_tmp16_, SYNC_TIME_MODULE_NAME, "try_adjtime_before_settime", FALSE);
	self->priv->try_adjtime = _tmp17_;
	_tmp18_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp19_ = self->priv->try_adjtime;
	_tmp20_ = bool_to_string (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_strconcat ("try_adjtime_before_settime = ", _tmp21_, NULL);
	_tmp23_ = _tmp22_;
	fso_framework_logger_debug (_tmp18_, _tmp23_);
	_g_free0 (_tmp23_);
	_g_free0 (_tmp21_);
	_tmp24_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp25_ = self->priv->sources;
	_tmp26_ = gee_abstract_map_get_size ((GeeMap*) _tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_strdup_printf ("%i", _tmp27_);
	_tmp29_ = _tmp28_;
	_tmp30_ = g_strconcat ("Ready. Configured for ", _tmp29_, " sources.", NULL);
	_tmp31_ = _tmp30_;
	fso_framework_logger_info (_tmp24_, _tmp31_);
	_g_free0 (_tmp31_);
	_g_free0 (_tmp29_);
	sourcenames = (_vala_array_free (sourcenames, sourcenames_length1, (GDestroyNotify) g_free), NULL);
	return self;
}


SyncTimeService* sync_time_service_new (FsoFrameworkSubsystem* subsystem) {
	return sync_time_service_construct (SYNC_TIME_TYPE_SERVICE, subsystem);
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static void _sync_time_service_onTimeReport_fso_time_source_report_time (FsoTimeSource* _sender, gint since_epoch, FsoTimeSource* source, gpointer self) {
	sync_time_service_onTimeReport (self, since_epoch, source);
}


static void _sync_time_service_onZoneReport_fso_time_source_report_zone (FsoTimeSource* _sender, const gchar* zone, FsoTimeSource* source, gpointer self) {
	sync_time_service_onZoneReport (self, zone, source);
}


static void _sync_time_service_onLocationReport_fso_time_source_report_location (FsoTimeSource* _sender, gdouble lat, gdouble lon, gint height, FsoTimeSource* source, gpointer self) {
	sync_time_service_onLocationReport (self, lat, lon, height, source);
}


void sync_time_service_addSource (SyncTimeService* self, const gchar* name) {
	gchar* _tmp0_;
	gchar* typename;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	static GQuark _tmp3_label2 = 0;
	static GQuark _tmp3_label3 = 0;
	static GQuark _tmp3_label4 = 0;
	const gchar* _tmp15_;
	GType _tmp16_ = 0UL;
	GType sourceclass;
	GType _tmp17_;
	GeeHashMap* _tmp25_;
	const gchar* _tmp26_;
	GType _tmp27_;
	GObject* _tmp28_ = NULL;
	GObject* _tmp29_;
	FsoTimeSource* _tmp30_;
	FsoFrameworkLogger* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_ = NULL;
	const gchar* _tmp34_;
	const gchar* _tmp35_ = NULL;
	gchar* _tmp36_ = NULL;
	gchar* _tmp37_;
	GeeHashMap* _tmp38_;
	const gchar* _tmp39_;
	gpointer _tmp40_ = NULL;
	FsoTimeSource* _tmp41_;
	GeeHashMap* _tmp42_;
	const gchar* _tmp43_;
	gpointer _tmp44_ = NULL;
	FsoTimeSource* _tmp45_;
	GeeHashMap* _tmp46_;
	const gchar* _tmp47_;
	gpointer _tmp48_ = NULL;
	FsoTimeSource* _tmp49_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	_tmp0_ = g_strdup ("unknown");
	typename = _tmp0_;
	_tmp1_ = name;
	_tmp2_ = _tmp1_;
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("ntp")))) {
		switch (0) {
			default:
			{
				gchar* _tmp5_;
				_tmp5_ = g_strdup ("SourceNtp");
				_g_free0 (typename);
				typename = _tmp5_;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("gps")))) {
		switch (0) {
			default:
			{
				gchar* _tmp6_;
				_tmp6_ = g_strdup ("SourceGps");
				_g_free0 (typename);
				typename = _tmp6_;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("gpsddbus")))) {
		switch (0) {
			default:
			{
				gchar* _tmp7_;
				_tmp7_ = g_strdup ("SourceGpsddbus");
				_g_free0 (typename);
				typename = _tmp7_;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("gsm")))) {
		switch (0) {
			default:
			{
				gchar* _tmp8_;
				_tmp8_ = g_strdup ("SourceGsm");
				_g_free0 (typename);
				typename = _tmp8_;
				break;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label4) ? _tmp3_label4 : (_tmp3_label4 = g_quark_from_static_string ("dummy")))) {
		switch (0) {
			default:
			{
				gchar* _tmp9_;
				_tmp9_ = g_strdup ("SourceDummy");
				_g_free0 (typename);
				typename = _tmp9_;
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				FsoFrameworkLogger* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_ = NULL;
				gchar* _tmp13_ = NULL;
				gchar* _tmp14_;
				_tmp10_ = ((FsoFrameworkAbstractObject*) self)->logger;
				_tmp11_ = name;
				_tmp12_ = string_to_string (_tmp11_);
				_tmp13_ = g_strconcat ("Unknown source ", _tmp12_, " - Ignoring", NULL);
				_tmp14_ = _tmp13_;
				fso_framework_logger_warning (_tmp10_, _tmp14_);
				_g_free0 (_tmp14_);
				_g_free0 (typename);
				return;
			}
		}
	}
	_tmp15_ = typename;
	_tmp16_ = g_type_from_name (_tmp15_);
	sourceclass = _tmp16_;
	_tmp17_ = sourceclass;
	if (_tmp17_ == G_TYPE_INVALID) {
		FsoFrameworkLogger* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_;
		const gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		_tmp18_ = ((FsoFrameworkAbstractObject*) self)->logger;
		_tmp19_ = name;
		_tmp20_ = string_to_string (_tmp19_);
		_tmp21_ = typename;
		_tmp22_ = string_to_string (_tmp21_);
		_tmp23_ = g_strconcat ("Can't find source ", _tmp20_, " (type=", _tmp22_, ") - plugin loaded?", NULL);
		_tmp24_ = _tmp23_;
		fso_framework_logger_warning (_tmp18_, _tmp24_);
		_g_free0 (_tmp24_);
		_g_free0 (typename);
		return;
	}
	_tmp25_ = self->priv->sources;
	_tmp26_ = name;
	_tmp27_ = sourceclass;
	_tmp28_ = g_object_new (_tmp27_, NULL);
	_tmp29_ = G_IS_INITIALLY_UNOWNED (_tmp28_) ? g_object_ref_sink (_tmp28_) : _tmp28_;
	_tmp30_ = FSO_TIME_SOURCE (_tmp29_);
	gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, _tmp26_, _tmp30_);
	_g_object_unref0 (_tmp30_);
	_tmp31_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp32_ = name;
	_tmp33_ = string_to_string (_tmp32_);
	_tmp34_ = typename;
	_tmp35_ = string_to_string (_tmp34_);
	_tmp36_ = g_strconcat ("Added source ", _tmp33_, " (", _tmp35_, ")", NULL);
	_tmp37_ = _tmp36_;
	fso_framework_logger_info (_tmp31_, _tmp37_);
	_g_free0 (_tmp37_);
	_tmp38_ = self->priv->sources;
	_tmp39_ = name;
	_tmp40_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp38_, _tmp39_);
	_tmp41_ = (FsoTimeSource*) _tmp40_;
	g_signal_connect_object (_tmp41_, "report-time", (GCallback) _sync_time_service_onTimeReport_fso_time_source_report_time, self, 0);
	_g_object_unref0 (_tmp41_);
	_tmp42_ = self->priv->sources;
	_tmp43_ = name;
	_tmp44_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp42_, _tmp43_);
	_tmp45_ = (FsoTimeSource*) _tmp44_;
	g_signal_connect_object (_tmp45_, "report-zone", (GCallback) _sync_time_service_onZoneReport_fso_time_source_report_zone, self, 0);
	_g_object_unref0 (_tmp45_);
	_tmp46_ = self->priv->sources;
	_tmp47_ = name;
	_tmp48_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, _tmp47_);
	_tmp49_ = (FsoTimeSource*) _tmp48_;
	g_signal_connect_object (_tmp49_, "report-location", (GCallback) _sync_time_service_onLocationReport_fso_time_source_report_location, self, 0);
	_g_object_unref0 (_tmp49_);
	_g_free0 (typename);
}


static gchar* sync_time_service_real_repr (FsoFrameworkAbstractObject* base) {
	SyncTimeService * self;
	gchar* result = NULL;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	self = (SyncTimeService*) base;
	_tmp0_ = self->priv->sources;
	_tmp1_ = gee_abstract_map_get_size ((GeeMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("<", _tmp4_, ">", NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	result = _tmp6_;
	return result;
}


void sync_time_service_onTimeReport (SyncTimeService* self, gint since_epoch, FsoTimeSource* source) {
	time_t _tmp0_;
	time_t now;
	gint _tmp1_;
	time_t _tmp2_;
	gint offset;
	FsoFrameworkLogger* _tmp3_;
	FsoTimeSource* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	time_t _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gint _tmp12_;
	struct timeval _tmp13_ = {0};
	struct timeval tvdiff;
	gboolean setHard;
	gboolean _tmp14_;
	gboolean _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = time (NULL);
	now = _tmp0_;
	_tmp1_ = since_epoch;
	_tmp2_ = now;
	offset = _tmp1_ - ((gint) _tmp2_);
	_tmp3_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp4_ = source;
	_tmp5_ = FSO_FRAMEWORK_ABSTRACT_OBJECT (_tmp4_)->classname;
	_tmp6_ = since_epoch;
	_tmp7_ = now;
	_tmp8_ = offset;
	_tmp9_ = g_strdup_printf ("%s reports %u, we think %u, offset = %d", _tmp5_, (guint) _tmp6_, (guint) _tmp7_, (gint) _tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = fso_framework_logger_debug (_tmp3_, _tmp10_);
	g_assert (_tmp11_);
	_g_free0 (_tmp10_);
	_tmp12_ = offset;
	memset (&_tmp13_, 0, sizeof (struct timeval));
	_tmp13_.tv_sec = (time_t) _tmp12_;
	tvdiff = _tmp13_;
	setHard = TRUE;
	_tmp14_ = self->priv->try_adjtime;
	if (_tmp14_) {
		struct timeval _tmp15_;
		gint _tmp16_ = 0;
		gint res;
		gint _tmp17_;
		_tmp15_ = tvdiff;
		_tmp16_ = adjtime (&_tmp15_, NULL);
		res = _tmp16_;
		_tmp17_ = res;
		if (_tmp17_ != 0) {
			FsoFrameworkLogger* _tmp18_;
			gint _tmp19_;
			const gchar* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			gchar* _tmp22_ = NULL;
			gchar* _tmp23_;
			_tmp18_ = ((FsoFrameworkAbstractObject*) self)->logger;
			_tmp19_ = errno;
			_tmp20_ = g_strerror (_tmp19_);
			_tmp21_ = string_to_string (_tmp20_);
			_tmp22_ = g_strconcat ("Can't adjtime(2): ", _tmp21_, "; setting it hard", NULL);
			_tmp23_ = _tmp22_;
			fso_framework_logger_warning (_tmp18_, _tmp23_);
			_g_free0 (_tmp23_);
		} else {
			setHard = FALSE;
		}
	}
	_tmp24_ = setHard;
	if (_tmp24_) {
		gint _tmp25_;
		struct timeval _tmp26_ = {0};
		struct timeval tvreal;
		gint _tmp27_ = 0;
		gint res;
		gint _tmp28_;
		_tmp25_ = since_epoch;
		memset (&_tmp26_, 0, sizeof (struct timeval));
		_tmp26_.tv_sec = (time_t) _tmp25_;
		tvreal = _tmp26_;
		_tmp27_ = settimeofday (&tvreal, NULL);
		res = _tmp27_;
		_tmp28_ = res;
		if (_tmp28_ != 0) {
			FsoFrameworkLogger* _tmp29_;
			gint _tmp30_;
			const gchar* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			gchar* _tmp33_ = NULL;
			gchar* _tmp34_;
			_tmp29_ = ((FsoFrameworkAbstractObject*) self)->logger;
			_tmp30_ = errno;
			_tmp31_ = g_strerror (_tmp30_);
			_tmp32_ = string_to_string (_tmp31_);
			_tmp33_ = g_strconcat ("Can't settimeofday(2): ", _tmp32_, NULL);
			_tmp34_ = _tmp33_;
			fso_framework_logger_warning (_tmp29_, _tmp34_);
			_g_free0 (_tmp34_);
		}
	}
}


void sync_time_service_onZoneReport (SyncTimeService* self, const gchar* zone, FsoTimeSource* source) {
	FsoFrameworkLogger* _tmp0_;
	FsoTimeSource* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* newzone;
	const gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	FsoFrameworkLogger* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_ = NULL;
	const gchar* _tmp32_;
	const gchar* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	gchar* _tmp35_;
	gboolean _tmp36_ = FALSE;
	const gchar* _tmp37_;
	gint _tmp38_ = 0;
	gint res;
	gint _tmp39_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	gint _tmp50_ = 0;
	gint _tmp51_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (zone != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp1_ = source;
	_tmp2_ = FSO_FRAMEWORK_ABSTRACT_OBJECT (_tmp1_)->classname;
	_tmp3_ = zone;
	_tmp4_ = g_strdup_printf ("%s reports time zone '%s'", _tmp2_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = fso_framework_logger_debug (_tmp0_, _tmp5_);
	g_assert (_tmp6_);
	_g_free0 (_tmp5_);
	_tmp7_ = self->priv->zoneinfo_dir;
	_tmp8_ = zone;
	_tmp9_ = g_build_filename (_tmp7_, _tmp8_, NULL);
	newzone = _tmp9_;
	_tmp10_ = newzone;
	_tmp11_ = fso_framework_file_handling_isPresent (_tmp10_);
	if (!_tmp11_) {
		FsoFrameworkLogger* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		_tmp12_ = ((FsoFrameworkAbstractObject*) self)->logger;
		_tmp13_ = newzone;
		_tmp14_ = string_to_string (_tmp13_);
		_tmp15_ = g_strconcat ("Timezone file ", _tmp14_, " not present; ignoring zone report", NULL);
		_tmp16_ = _tmp15_;
		fso_framework_logger_warning (_tmp12_, _tmp16_);
		_g_free0 (_tmp16_);
		_g_free0 (newzone);
		return;
	} else {
		{
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			_tmp17_ = self->priv->timezone_file;
			_tmp18_ = zone;
			_tmp19_ = g_strconcat (_tmp18_, "\n", NULL);
			_tmp20_ = _tmp19_;
			g_file_set_contents (_tmp17_, _tmp20_, (gssize) (-1), &_inner_error_);
			_g_free0 (_tmp20_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_FILE_ERROR) {
					goto __catch0_g_file_error;
				}
				_g_free0 (newzone);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally0;
		__catch0_g_file_error:
		{
			GError* e = NULL;
			FsoFrameworkLogger* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_ = NULL;
			GError* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_ = NULL;
			gchar* _tmp27_ = NULL;
			gchar* _tmp28_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp21_ = ((FsoFrameworkAbstractObject*) self)->logger;
			_tmp22_ = self->priv->timezone_file;
			_tmp23_ = string_to_string (_tmp22_);
			_tmp24_ = e;
			_tmp25_ = _tmp24_->message;
			_tmp26_ = string_to_string (_tmp25_);
			_tmp27_ = g_strconcat ("Can't write to ", _tmp23_, ": ", _tmp26_, NULL);
			_tmp28_ = _tmp27_;
			fso_framework_logger_warning (_tmp21_, _tmp28_);
			_g_free0 (_tmp28_);
			_g_error_free0 (e);
		}
		__finally0:
		if (_inner_error_ != NULL) {
			_g_free0 (newzone);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp29_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp30_ = self->priv->localtime_file;
	_tmp31_ = string_to_string (_tmp30_);
	_tmp32_ = newzone;
	_tmp33_ = string_to_string (_tmp32_);
	_tmp34_ = g_strconcat ("Removing ", _tmp31_, " and symlinking to ", _tmp33_, NULL);
	_tmp35_ = _tmp34_;
	_tmp36_ = fso_framework_logger_debug (_tmp29_, _tmp35_);
	g_assert (_tmp36_);
	_g_free0 (_tmp35_);
	_tmp37_ = self->priv->localtime_file;
	_tmp38_ = g_remove (_tmp37_);
	res = _tmp38_;
	_tmp39_ = res;
	if (_tmp39_ != 0) {
		FsoFrameworkLogger* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp42_ = NULL;
		gint _tmp43_;
		const gchar* _tmp44_ = NULL;
		const gchar* _tmp45_ = NULL;
		gchar* _tmp46_ = NULL;
		gchar* _tmp47_;
		_tmp40_ = ((FsoFrameworkAbstractObject*) self)->logger;
		_tmp41_ = self->priv->localtime_file;
		_tmp42_ = string_to_string (_tmp41_);
		_tmp43_ = errno;
		_tmp44_ = g_strerror (_tmp43_);
		_tmp45_ = string_to_string (_tmp44_);
		_tmp46_ = g_strconcat ("Can't remove ", _tmp42_, ": ", _tmp45_, NULL);
		_tmp47_ = _tmp46_;
		fso_framework_logger_warning (_tmp40_, _tmp47_);
		_g_free0 (_tmp47_);
	}
	_tmp48_ = newzone;
	_tmp49_ = self->priv->localtime_file;
	_tmp50_ = symlink (_tmp48_, _tmp49_);
	res = _tmp50_;
	_tmp51_ = res;
	if (_tmp51_ != 0) {
		FsoFrameworkLogger* _tmp52_;
		const gchar* _tmp53_;
		const gchar* _tmp54_ = NULL;
		const gchar* _tmp55_;
		const gchar* _tmp56_ = NULL;
		gint _tmp57_;
		const gchar* _tmp58_ = NULL;
		const gchar* _tmp59_ = NULL;
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_;
		_tmp52_ = ((FsoFrameworkAbstractObject*) self)->logger;
		_tmp53_ = self->priv->localtime_file;
		_tmp54_ = string_to_string (_tmp53_);
		_tmp55_ = newzone;
		_tmp56_ = string_to_string (_tmp55_);
		_tmp57_ = errno;
		_tmp58_ = g_strerror (_tmp57_);
		_tmp59_ = string_to_string (_tmp58_);
		_tmp60_ = g_strconcat ("Can't symlink ", _tmp54_, " -> ", _tmp56_, ": ", _tmp59_, NULL);
		_tmp61_ = _tmp60_;
		fso_framework_logger_warning (_tmp52_, _tmp61_);
		_g_free0 (_tmp61_);
	} else {
		struct tm t = {0};
		memset (&t, 0, sizeof (struct tm));
		mktime (&t);
	}
	_g_free0 (newzone);
}


void sync_time_service_onLocationReport (SyncTimeService* self, gdouble lat, gdouble lon, gint height, FsoTimeSource* source) {
	FsoFrameworkLogger* _tmp0_;
	FsoTimeSource* _tmp1_;
	const gchar* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	_tmp0_ = ((FsoFrameworkAbstractObject*) self)->logger;
	_tmp1_ = source;
	_tmp2_ = FSO_FRAMEWORK_ABSTRACT_OBJECT (_tmp1_)->classname;
	_tmp3_ = lat;
	_tmp4_ = lon;
	_tmp5_ = height;
	_tmp6_ = g_strdup_printf ("%s reports position %.2f %.2f - %d", _tmp2_, _tmp3_, _tmp4_, _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = fso_framework_logger_debug (_tmp0_, _tmp7_);
	g_assert (_tmp8_);
	_g_free0 (_tmp7_);
}


static void sync_time_service_class_init (SyncTimeServiceClass * klass) {
	sync_time_service_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SyncTimeServicePrivate));
	FSO_FRAMEWORK_ABSTRACT_OBJECT_CLASS (klass)->repr = sync_time_service_real_repr;
	G_OBJECT_CLASS (klass)->finalize = sync_time_service_finalize;
}


static void sync_time_service_instance_init (SyncTimeService * self) {
	self->priv = SYNC_TIME_SERVICE_GET_PRIVATE (self);
}


static void sync_time_service_finalize (GObject* obj) {
	SyncTimeService * self;
	self = SYNC_TIME_SERVICE (obj);
	_g_object_unref0 (self->priv->subsystem);
	_g_object_unref0 (self->priv->sources);
	_g_free0 (self->priv->timezone_file);
	_g_free0 (self->priv->localtime_file);
	_g_free0 (self->priv->zoneinfo_dir);
	G_OBJECT_CLASS (sync_time_service_parent_class)->finalize (obj);
}


GType sync_time_service_get_type (void) {
	return sync_time_service_type_id;
}


GType sync_time_service_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (SyncTimeServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sync_time_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SyncTimeService), 0, (GInstanceInitFunc) sync_time_service_instance_init, NULL };
	sync_time_service_type_id = g_type_module_register_type (module, FSO_FRAMEWORK_TYPE_ABSTRACT_OBJECT, "SyncTimeService", &g_define_type_info, 0);
	return sync_time_service_type_id;
}


/**
 * This function gets called on plugin initialization time.
 * @return the name of your plugin here
 * @note that it needs to be a name in the format <subsystem>.<plugin>
 * else your module will be unloaded immediately.
 **/
gchar* fso_factory_function (FsoFrameworkSubsystem* subsystem, GError** error) {
	gchar* result = NULL;
	FsoFrameworkSubsystem* _tmp0_;
	SyncTimeService* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (subsystem != NULL, NULL);
	_tmp0_ = subsystem;
	_tmp1_ = sync_time_service_new (_tmp0_);
	_g_object_unref0 (service);
	service = _tmp1_;
	_tmp2_ = g_strdup (SYNC_TIME_MODULE_NAME);
	result = _tmp2_;
	return result;
}


void fso_register_function (GTypeModule* module) {
	FsoFrameworkLogger* _tmp0_;
	g_return_if_fail (module != NULL);
	sync_time_service_register_type (module);
	_tmp0_ = fso_framework_theLogger;
	fso_framework_logger_debug (_tmp0_, "fsotdl.sync_time fso_register_function");
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



